package token;

import java.util.function.Supplier;

import file.FilePosition;
import sexpression.*;

public class QuoteMark extends Token {

    public QuoteMark(String text, FilePosition position) {
        super(text, position);
    }

    @Override
    public SExpression sExpr(Supplier<Token> getNextToken) {
        Token nextToken = getNextToken.get();
        SExpression argument = nextToken.sExpr(getNextToken);

        return new Cons(new Symbol("QUOTE"), new Cons(argument, Nil.getUniqueInstance()));
    }

}
